From f6042d28f4d625b6727f48a06dd3839fdf48e351 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 07 2017 16:03:55 +0000
Subject: [PATCH 2/51] add 'lint' command


This only checks the summary at the moment.

---

diff --git a/src/_fedmod/cli.py b/src/_fedmod/cli.py
index a6d3be5..b238d0a 100644
--- a/src/_fedmod/cli.py
+++ b/src/_fedmod/cli.py
@@ -4,6 +4,8 @@ import logging
 
 from .module_generator import ModuleGenerator
 from .module_repoquery import ModuleRepoquery
+from .modulemd_linter import ModuleMDLinter
+
 from . import _depchase, _repodata, _fetchrepodata
 
 # fedmod uses click for argument parsing, but currently does its own
@@ -129,3 +131,11 @@ def rpms_from_srpm(pkg):
     """Reports which RPMS are generated from the given SRPM"""
     rq = ModuleRepoquery()
     rq.get_rpms_for_srpm(pkg)
+
+# Check a modulemd YAML file for validity.
+@_cli_commands.command('lint')
+@click.argument("modulemd")
+def lint(modulemd):
+    """Validates a given modulemd YAML file"""
+    linter = ModuleMDLinter(modulemd_path=modulemd)
+    linter.lint()
diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
new file mode 100644
index 0000000..109b134
--- /dev/null
+++ b/src/_fedmod/modulemd_linter.py
@@ -0,0 +1,120 @@
+import inspect
+from functools import reduce
+
+import modulemd
+
+
+class guidelines_link(object):
+    """Decorate a linter method with a link to the guidelines (can be a full
+    URL or just an anchor on the main wiki page)."""
+
+    guidelines_base_url = "https://fedoraproject.org/wiki/Module:Guidelines"
+
+    def __init__(self, link):
+        self.link = link
+
+    def __call__(self, fn):
+        if "://" in self.link:
+            fn.lint_guidelines_url = self.link
+        else:
+            anchor = self.link
+            if anchor.startswith("#"):
+                anchor = anchor[1:]
+            fn.lint_guidelines_url = "{}#{}".format(self.guidelines_base_url,
+                                                    anchor)
+        return fn
+
+
+class LintLevelDecorator(object):
+    """Decorator to specify a 'severity' level for a linter method."""
+
+    all_levels = set()
+
+    def __init__(self, level):
+        assert(level not in self.all_levels)
+        self.level = level
+        self.all_levels.add(level)
+
+    def __call__(self, fn):
+        fn.lint_level = self.level
+        return fn
+
+
+info = LintLevelDecorator("info")
+warning = LintLevelDecorator("warning")
+error = LintLevelDecorator("error")
+
+
+class ModuleMDLinter(object):
+    """Linter for modulemd YAML files or data."""
+
+    def __init__(self, modulemd_path=None, modulemd_str=None):
+        if bool(modulemd_path) == bool(modulemd_str):
+            raise ValueError(
+                "specify exactly one of modulemd_path or modulemd_str")
+
+        mmd = self.mmd = modulemd.ModuleMetadata()
+
+        self.modulemd_path = modulemd_path
+
+        if not modulemd_str:
+            with open(modulemd_path, "r") as mmdfile:
+                self.modulemd_str = mmdfile.read()
+        else:
+            self.modulemd_str = modulemd_str
+
+        mmd.loads(self.modulemd_str)
+
+    def lint(self, levels=LintLevelDecorator.all_levels):
+        assert set(levels) <= LintLevelDecorator.all_levels
+
+        lint_method_names = [x for x in dir(self) if x.startswith("lint_")]
+
+        lint_methods = [y for y in
+                        (getattr(self, x) for x in lint_method_names)
+                        if callable(y) and y.lint_level in levels]
+
+        assert all(getattr(x, "lint_level", None)
+                   in LintLevelDecorator.all_levels
+                   for x in lint_methods)
+
+        flagged = []
+
+        for method in lint_methods:
+            try:
+                method()
+            except Exception as e:
+                flagged.append((method.lint_level, inspect.getdoc(method),
+                                method.lint_guidelines_url, e))
+
+        longest_level_len = reduce(lambda x, y: max(x, len(y)),
+                                   LintLevelDecorator.all_levels, 0)
+
+        for i, (lvl, text, url, exc) in enumerate(flagged):
+            print("[{lvl: <{len}}] {url}".format(lvl=lvl,
+                                                 len=longest_level_len,
+                                                 url=url or ""))
+            for l in text.split("\n"):
+                print("\t" + l)
+
+            if i < len(flagged) - 1:
+                print()
+
+    @error
+    @guidelines_link('#Module_summary_and_description')
+    def lint_summary_exists(self):
+        """Every module MUST include a short summary."""
+        assert self.mmd.summary and self.mmd.summary.strip()
+
+    @error
+    @guidelines_link('#Module_summary_and_description')
+    def lint_summary_one_sentence(self):
+        """The module summary is a one sentence concise description of the
+        module."""
+        assert "." not in self.mmd.summary[:-1]
+
+    @warning
+    @guidelines_link('#Module_summary_and_description')
+    def lint_summary_no_trailing_period(self):
+        """The summary SHOULD NOT end in a period."""
+        assert not self.mmd.summary.strip().endswith(".")

